
import java.io.*;

import java.awt.image.*;
import java.awt.color.*;
import java.awt.*;

/** Really ugly and minimal code to read a TGA file. This code has
    severe limitations, and probably will fail to read any TGA file
    other than the one it was coded to read.  */

public class TgaParser {

    int width;
    int height;
    DataBufferByte data;

    ColorModel colorModel;
    ComponentSampleModel sampleModel;
    WritableRaster wRaster;

    DataInputStream input;
    public TgaParser(InputStream input) throws IOException {
	this.input = new DataInputStream(input);

	byte[] junk1 = new byte[0x0c];
	readComplete(junk1);
	
	width = readUnsignedLittleEndianShort();
	height = readUnsignedLittleEndianShort();
	
	byte[] junk2 = new byte[0x2c];
	readComplete(junk2);

	int pixelStride = 3;
	int scanlineStride = pixelStride*width;
	int[] bandOffsets = { 2, 1, 0 };

	sampleModel =
	    new ComponentSampleModel(DataBuffer.TYPE_BYTE, width, height,
				     pixelStride, scanlineStride,
				     bandOffsets);
	wRaster = Raster.createWritableRaster(sampleModel, new Point(0, 0));

	data = (DataBufferByte) wRaster.getDataBuffer();
	readComplete(data.getData());


	// ---- static: ----

	ColorSpace sRGB = ColorSpace.getInstance(ColorSpace.TYPE_sRGB);
	int[] bits = { 8, 8, 8 };
	colorModel =
	    new ComponentColorModel(sRGB,  // colorspace
				    bits,  // 8 bits per sample
				    false, // no alpha
				    false, // not alpha premultiplied,
				    Transparency.OPAQUE,
				    DataBuffer.TYPE_BYTE // transferType
				    );

    }

    public int readUnsignedLittleEndianShort() throws IOException {
	return input.readUnsignedByte() | (input.readUnsignedByte() << 8);
    }

    public void readComplete(byte[] buffer) throws IOException {
	int length = buffer.length;
	for (int offset=0; offset<length;) {
	    int result = input.read(buffer, offset, length-offset);
	    if (result == -1) throw new EOFException();
	    offset += result;	   
	}
    }
}
