package java.awt.color;


public abstract class ColorSpace {
    // FIXME: Just guesses:
    public static final int TYPE_XYZ = 0;
    public static final int TYPE_Lab = 1;
    public static final int TYPE_Luv = 2;
    public static final int TYPE_YCbCr = 3;
    public static final int TYPE_Yxy = 4;
    public static final int TYPE_RGB = 5;
    public static final int TYPE_GRAY = 6;
    public static final int TYPE_HSV = 7;
    public static final int TYPE_HLS = 8;
    public static final int TYPE_CMYK = 9;
    public static final int TYPE_CMY = 10;
    public static final int TYPE_2CLR = 11;
    public static final int TYPE_3CLR = 12;
    public static final int TYPE_4CLR = 13;
    public static final int TYPE_5CLR = 14;
    public static final int TYPE_6CLR = 15;
    public static final int TYPE_7CLR = 16;
    public static final int TYPE_8CLR = 17;
    public static final int TYPE_9CLR = 18;
    public static final int TYPE_ACLR = 19;
    public static final int TYPE_BCLR = 20;
    public static final int TYPE_CCLR = 21;
    public static final int TYPE_DCLR = 22;
    public static final int TYPE_ECLR = 23;
    public static final int TYPE_FCLR = 24;
    public static final int TYPE_sRGB = 25;

    public static final int CS_LINEAR_RGB = 26;
    public static final int CS_CIEXYZ = 27;
    public static final int CS_PYCC = 28;
    public static final int CS_GRAY = 29;

    private static final ColorSpace INSTANCE_sRGB = new ICC_ColorSpace(null);

    private int type;
    private int numcomponents;
    protected ColorSpace(int type, int numcomponents) {
	this.type = type;
	this.numcomponents = numcomponents;
    }
	
    public static ColorSpace getInstance(int colorspace) {
	switch (colorspace) {
	case TYPE_sRGB:
	    // FIXME: provide proper implementation. This is a kludge.
	    return INSTANCE_sRGB;
	}
	throw new UnsupportedOperationException();
    }
	
    public boolean isCS_sRGB() {
	return false;
    }

    public abstract float[] toRGB(float[] colorvalue);

    public abstract float[] fromRGB(float[] rgbvalue);

    public abstract float[] toCIEXYZ(float[] colorvalue);

    public abstract float[] fromCIEXYZ(float[] colorvalue);

    public int getType() {
	return type;
    }

    public int getNumComponents() {
	return numcomponents;
    }

    public String getName(int idx) {
	return "type " + type;
    }

    public String toString() {
	return getClass().getName() + "[type=" + type + "]";
    }
}
