package no.rwr.image;

import java.awt.image.*;
import no.rwr.data.Buffers;

public class PixelCopyOp implements RasterOp {

    public WritableRaster filter(Raster src, WritableRaster dest) {
	if (dest == null) dest = createCompatibleDestRaster(src);

	int w = src.getWidth();
	int h = src.getHeight();

	int[] pixels = src.getPixels(src.getMinX(), src.getMinY(),
				     w, h,
				     (int[]) null);
	
	dest.setPixels(dest.getMinX(), dest.getMinY(), w, h, pixels);
	return dest;	
    }

    public WritableRaster createCompatibleDestRaster(Raster src) {

	/* FIXME: Maybe attempt to try to create a more optimized
	   sample model? */
	return src.createCompatibleWritableRaster();
    }
}
