
#include <X11/Xlib.h>

#include <cni.h>
#include <gnu/gcj/RawData.h>
#include <java/lang/String.h>

#include "no/rwr/x/Display.h"
#include "no/rwr/x/Font.h"

jint no::rwr::x::Font::loadFontXID(Display* display, jstring lfdNamePattern) {
    ::Display* dpy = (::Display*) display->display;
    int len = JvGetStringUTFLength(lfdNamePattern);
    char cName[len+1];
    JvGetStringUTFRegion(lfdNamePattern, 0, lfdNamePattern->length(),
			 cName);
    cName[len] = '\0';
    int xid = XLoadFont(dpy, cName);
    return xid;
}

void no::rwr::x::Font::finalize() {
    if (xid != 0) {
	::Display* dpy = (::Display*) display->display;
	XUnloadFont(dpy, xid);
	xid = 0;
    }
}
