
#include <X11/Xlib.h>

#include <cni.h>
#include <gnu/gcj/RawData.h>

#include "no/rwr/x/Display.h"
#include "no/rwr/x/Window.h"
#include "no/rwr/x/WindowAttributes.h"
#include "no/rwr/x/Pixmap.h"


void no::rwr::x::WindowAttributes::init(WindowAttributes* copyFrom) {
    XSetWindowAttributes* attributes = new XSetWindowAttributes;

    if (copyFrom != 0) {
	XSetWindowAttributes* from = 
	    (XSetWindowAttributes*) copyFrom->structure;
	(*attributes) = (*from);
    } 

    structure = reinterpret_cast<gnu::gcj::RawData*>(attributes);
}

void no::rwr::x::WindowAttributes::finalize() {
    delete structure;
}

void no::rwr::x::WindowAttributes::setBackground(jlong pixel) {
    XSetWindowAttributes* attributes = (XSetWindowAttributes*) structure;

    attributes->background_pixel = pixel;
    mask = mask | CWBackPixel;
}

void no::rwr::x::WindowAttributes::setBackground(Pixmap* pixmap) {
    XSetWindowAttributes* attributes = (XSetWindowAttributes*) structure;

    attributes->background_pixmap = pixmap->getXID();
    mask = mask | CWBackPixmap;
}

void no::rwr::x::WindowAttributes::setEventMask(jlong eventMask) {
    XSetWindowAttributes* attributes = (XSetWindowAttributes*) structure;

    attributes->event_mask = eventMask;
    mask = mask | CWEventMask;
}

void no::rwr::x::WindowAttributes::apply(Window* window) {
    ::Display* dpy = (::Display*) window->getDisplay()->display;
    ::Window win = window->getXID();
    XSetWindowAttributes* attributes = (XSetWindowAttributes*) structure;

    XChangeWindowAttributes(dpy, win, mask, attributes);
}
