package no.rwr.xutil;

import no.rwr.x.*;


public class TopLevelWindow extends Canvas {

    WMSizeHints normalSizeHints;

    public TopLevelWindow() {
	visible = false;
    }
    public void setScreen(Screen screen) {
	setParent(screen.getRootWindow());
    }
    public void setNormalSizeHints(WMSizeHints hints) {
	normalSizeHints = hints;
	checkNormalSizeHints();
	if (normalSizeHints == null) {
	    // save private copy
	    normalSizeHints = (WMSizeHints) normalSizeHints.clone();
	}
    }
     private void checkNormalSizeHints() {
	if (!(valid && mapped)) return;
	if (normalSizeHints == null) return;
	
	normalSizeHints.applyNormalHints(getWindow());
	normalSizeHints = null;
     }

    public void setGroupLeader(TopLevelWindow leader) {
	// FIXME TODO
    }

    public void whenMapped() {
	checkNormalSizeHints();

	// Call super. Doing this, and doing this last, is very important.
	super.whenMapped();
    }

    public void processClientMessage(ClientMessageEvent message) {
	Display display = getWindow().getDisplay();
	int xa_WM_PROTOCOLS = display.getAtom("WM_PROTOCOLS");
	int xa_WM_DELETE_WINDOW = display.getAtom("WM_DELETE_WINDOW");

	if (message.getMessageTypeAtom() == xa_WM_PROTOCOLS) {
	    int protocolAtom = message.getInt(0);
	    String protocol = display.getAtomName(protocolAtom);
	    System.err.println("Window manager is bothering me with: " +
			       protocol);
	}

	System.err.println("Unknown client message: " + message);
	super.processClientMessage(message);
    }

}
